import wx
from Resources import *

_defaultCompilers = ["py2exe", "py2app", "cx_Freeze", "PyInstaller"]

ListType = type([])
StringType = type("")

_lbStyle = INB_BORDER | INB_USE_PIN_BUTTON | INB_RIGHT | INB_GRADIENT_BACKGROUND

_auiImageList = ["project_ok", "project_unsaved", "project_broken"]
_treeIcons = ["project_home", "project", "project_edit"]
_iconFromName = {"includes": ["modules"],
                 "excludes": ["modules"],
                 "ignores": ["modules"],
                 "packages": ["packages"],
                 "dll_excludes": ["dllicon"],
                 "data_files": ["datafiles"],
                 "icon_resources": ["icon"],
                 "bitmap_resources": ["bitmap"],
                 "other_resources": ["resource"],
                 "messages": ["message_info", "message_warning", "message_error",
                              "message_find", "message_compile", "message_copy"],
                 "missingmodules": ["missingmodules"],
                 "binarydependencies": ["binarydependencies"]
                 }
_unWantedLists = ["messages", "missingmodules", "binarydependencies"]
_bookIcons = ["py2exe", "py2app", "cx_Freeze", "PyInstaller"]
_iconMapper = {"Message": 0, "Warning": 1, "Error": 2, "Find": 3, "Compile": 4, "Copy": 5}

_pywild = "Python source (*.py)|*.py"

if wx.Platform == '__WXMSW__':
    _faces = { 'times': 'Times New Roman',
               'mono' : 'Courier New',
               'helv' : 'Arial',
               'other': 'Comic Sans MS',
               'size' : 10,
               'size2': 8,
             }
elif wx.Platform == '__WXMAC__':
    _faces = { 'times': 'Times New Roman',
               'mono' : 'Courier New',
               'helv' : 'Arial',
               'other': 'Comic Sans MS',
               'size' : 12,
               'size2': 10,
             }
else:
    _faces = { 'times': 'Times',
               'mono' : 'Courier',
               'helv' : 'Helvetica',
               'other': 'new century schoolbook',
               'size' : 12,
               'size2': 10,
             }



_imports = '''
# ======================================================#
# File automagically generated by GUI2Exe version %(gui2exever)s
# Andrea Gavana, 31 March 2007
# ======================================================#

# Let's start with some default (for me) imports...

from distutils.core import setup
import py2exe
import glob
import os
import zlib
import shutil

%(remove_build)s
'''

_manifest_template = '''
manifest_template = """
<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<assembly xmlns="urn:schemas-microsoft-com:asm.v1" manifestVersion="1.0">
<assemblyIdentity
    version="5.0.0.0"
    processorArchitecture="x86"
    name="%(prog)s"
    type="win32"
/>
<description>%(prog)s Program</description>
<dependency>
    <dependentAssembly>
        <assemblyIdentity
            type="win32"
            name="Microsoft.Windows.Common-Controls"
            version="6.0.0.0"
            processorArchitecture="X86"
            publicKeyToken="6595b64144ccf1df"
            language="*"
        />
    </dependentAssembly>
</dependency>
</assembly>
"""
'''

_target = '''
class Target(object):
    """ A simple class that holds information on our executable file. """
    def __init__(self, **kw):
        """ Default class constructor. Update as you need. """
        self.__dict__.update(kw)
        # for the versioninfo resources
        self.version = "%(version)s"
        self.company_name = "%(company)s"
        self.copyright = "%(copyright)s"
        self.name = "%(name)s"


# Ok, let's explain why I am doing that.
# Often, data_files, excludes and dll_excludes (but also resources)
# can be very long list of things, and this will clutter too much
# the setup call at the end of this file. So, I put all the big lists
# here and I wrap them using the textwrap module.

data_files = %(data_files)s

includes = %(includes)s
excludes = %(excludes)s
packages = %(packages)s
dll_excludes = %(dll_excludes)s
icon_resources = %(icon_resources)s
bitmap_resources = %(bitmap_resources)s
other_resources = %(other_resources)s


# This is a place where the user custom code may go. You can do almost
# whatever you want, even modify the data_files, includes and friends
# here as long as they have the same variable name that the setup call
# below is expecting.

%(customcode)s


# Ok, now we are going to build our target class.
# I chose this building strategy as it works perfectly for me :-D

test_wx = Target(
    # what to build
    script = "%(script)s",
    icon_resources = icon_resources,
    bitmap_resources = bitmap_resources,
    other_resources = other_resources
    )


# That's serious now: we have all (or almost all) the options py2exe
# supports. I put them all even if some of them are usually defaulted
# and not used. Some of them I didn't even know about.

setup(

    data_files = data_files,

    options = {"py2exe": {"compressed": %(compressed)s, 
                          "optimize": %(optimize)s,
                          "includes": includes,
                          "excludes": excludes,
                          "packages": packages,
                          "dll_excludes": dll_excludes,
                          "bundle_files": %(bundle_files)s,
                          "dist_dir": "%(dist_dir)s",
                          "xref": %(xref)s,
                          "skip_archive": %(skip_archive)s,
                          "ascii": %(ascii)s,
                          "custom_boot_script": %(custom_boot_script)s,
                         }
              },

    zipfile = %(zipfile)s,
    %(kind)s = [test_wx]
    )


# And we are done. That's a setup script :-D

'''
